J = 100; %Number of grid points
y = 0:1/(J+1):1; %values of x at grid points
dx = 1/(J+1); %Spatial step
s=0.45;  %<0.5 for stability
dt = s*dx^2; %Time step for stability

T = 0.2; %Final time
M = floor(T/dt); %Number of iterations

x = y(2:end-1);
f = double(x>0.5); %Initial heat distribution
f = x.^2;

ymin = min(f);
ymax = max(f);


plot(y,[0,f,0]);
pause;
key_pressed=0;
set(gcf, 'KeyPressFcn', 'key_pressed=mod(key_pressed+1,2);')

u=f;  %Initial condition

%Press any key to stop/start simulation
for i=1:M
    
    un = [u(2:end),0]; %u^n_{j+1}
    up = [0,u(1:end-1)]; %u^n_{j-1}
    
    u = (1-2*s)*u + s*(un + up);
    
    %Draw u
    plot(y,[0,u,0]);
    ylim([ymin ymax]);
    drawnow;
    
    %Pause when key is pressed
    while key_pressed == 1
        pause(0.1);
    end
end
